/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package dpop;

/**
 *
 * @author Andrea
 */
public class IntegerValue extends Value implements Comparable {
    private int _value;
    IntegerValue(int value) {
        _value = value;
    }

    @Override
    public void setNeutralElement() {
        _value = 0;
    }

    @Override
    public int compareTo(Object o) {
        return _value - ((IntegerValue)o)._value;
    }

    @Override
    public Value subtract(Value s) {
        return new IntegerValue(_value - ((IntegerValue)s)._value);
    }

    @Override
    public Value sum(Value s) {
        return new IntegerValue(_value + ((IntegerValue)s)._value);
    }

    @Override
    public String toString() {
        return "" + _value + "";
    }

    public int getValue() {
        return _value;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final IntegerValue other = (IntegerValue) obj;
        if (this._value != other._value) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 3;
        hash = 29 * hash + this._value;
        return hash;
    }
}
