/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package dpop;

import java.util.*;
import java.lang.*;
import java.io.*;

/**
 *
 * @author Andrea
 */
public class ValuesIterator implements Iterator<TaggedDictionary<PseudoTreeNode, Value>> {
    private ArrayList<PseudoTreeNode> _variables;
    private TaggedDictionary<PseudoTreeNode, Value> _current_configuration;
    private TaggedDictionary<PseudoTreeNode, MyIterator<Value>> _iterators;

    private final class MyIterator<E> implements Iterator<E> {
        private ArrayList<E> _arr;
        private int _pointer;

        MyIterator(ArrayList<E> arr) {
            _arr = arr;
            _pointer = 0;
        }

        public boolean hasNext() {
            return _pointer < _arr.size();
        }

        //when the iterator reaches the end, resets the pointer and starts again
        //from the beginning
        public E next() {
            if (_pointer == _arr.size()) {
                //reset the pointer
                _pointer = 0;
            }

            if (_pointer < _arr.size()) {
               E res = _arr.get(_pointer);
                _pointer++;

                return res;
            }
            else {
               return null;
            }
        }

        public void remove() {
            //not used
        }

    }


    ValuesIterator(ArrayList<PseudoTreeNode> variables) {
        _variables = variables;
        _current_configuration = new TaggedDictionary<PseudoTreeNode, Value>();
        _iterators = new TaggedDictionary<PseudoTreeNode, MyIterator<Value>>();
        
        Iterator<PseudoTreeNode> v = _variables.iterator();
        while (v.hasNext()) {
            PseudoTreeNode agent = v.next();
            ArrayList<Value> current_domain = agent.getDomain();
            MyIterator<Value> current_iterator = new MyIterator<Value>(current_domain);
            //Iterator<Value> current_iterator = current_domain.iterator();

            //if a domain is empty, exception
            if (current_iterator.hasNext()) {
                
            }

            _iterators.put(agent, current_iterator);
        }
    }

    public boolean hasNext() {
        Iterator<Iterator<Value>> it = _iterators.values().iterator();
        boolean end = false;

        while (it.hasNext()) {
            Iterator<Value> current_iterator = it.next();

            if (current_iterator.hasNext()) {
                end = true;
                break;
            }
        }

        //true if at least 1 iterator has next, false otherwise
        return end;
    }

    private void _calculate_current_configuration() {
        //starts from the end of the _iterators and try to do a next() action
        //on an interator. if the iterator doesn't has next, it is reset
        //and the previous iterator is tested, until 1 iterator can do a next()
        //action. then the current configuration is returned
        if (_current_configuration.size() == 0) {
            //the first configuration
            Set<Map.Entry<PseudoTreeNode, MyIterator<Value>>> s = _iterators.entrySet();
            Iterator<Map.Entry<PseudoTreeNode, MyIterator<Value>>> it = s.iterator();
            while (it.hasNext()) {
                Map.Entry<PseudoTreeNode, MyIterator<Value>> e = it.next();
                Iterator<Value> current_iterator = e.getValue();

                Value first_value = current_iterator.next();

                _current_configuration.put(e.getKey(), first_value);
            }
        }
        else {
            Object elements[] = _iterators.entrySet().toArray();
            for (int i = elements.length - 1; i >= 0; i--) {
                Map.Entry<PseudoTreeNode, MyIterator<Value>> e = (Map.Entry<PseudoTreeNode, MyIterator<Value>>)elements[i];
                MyIterator<Value> current_iterator = e.getValue();
                PseudoTreeNode current_agent = e.getKey();

                if (current_iterator.hasNext()) {
                    _current_configuration.put(current_agent, current_iterator.next());
                    break;
                }
                else {
                    _current_configuration.put(current_agent, current_iterator.next());
                }
            }
        }
    }

    //returns a dictionary with each node associated to the value
    //of its domain depending to the current configuration of values calculated
    public TaggedDictionary<PseudoTreeNode, Value> next() {
        //calculate the next configuration
        _calculate_current_configuration();

        return _current_configuration;
    }

    public void remove() {
        //not used
    }

    public Value getLastValue(PseudoTreeNode n) {
        ArrayList<Value> domain = n.getDomain();
        return domain.get(domain.size() -1);
    }
}
