/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * ViewGraph.java
 *
 * Created on 28-mar-2010, 10.21.24
 */

package dpop;

import org.jgraph.JGraph;
import org.jgraph.graph.DefaultEdge;
import org.jgraph.graph.DefaultGraphCell;
import org.jgraph.graph.DefaultGraphModel;
import org.jgraph.graph.GraphConstants;
import org.jgraph.graph.GraphModel;
import com.jgraph.layout.organic.*;
import com.jgraph.layout.tree.*;
import com.jgraph.layout.hierarchical.*;

import java.awt.geom.Rectangle2D;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;

import com.jgraph.layout.*;
import java.awt.Color;

import java.util.Map;
import javax.swing.tree.*;
import java.util.Iterator;
import java.util.ArrayList;
import javax.swing.*;

/**
 *
 * @author Andrea
 */
public class ViewGraph extends javax.swing.JFrame {
    private JGraph _graph;
    
    /** Creates new form ViewGraph */
    public ViewGraph() {
        initComponents();

        _graph = null;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("Form"); // NOI18N

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ViewGraph().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables

    private void _create_basic_graph() {
        GraphModel model = new DefaultGraphModel();
        _graph = new JGraph(model);
        _graph.setEditable(false);
    }

    public void readGraph(GraphNode n) {
        _create_basic_graph();
        
        TaggedDictionary<GraphNode, DefaultGraphCell> visited = new TaggedDictionary<GraphNode, DefaultGraphCell>();
        _make_graph_from_graphnode(n, visited, null);
        
        //layout
        JGraphFacade facade = new JGraphFacade(_graph);
        JGraphFastOrganicLayout layout = new JGraphFastOrganicLayout();
        layout.setForceConstant(130);
        layout.run(facade);
        Map nested = facade.createNestedMap(true, true);
        _graph.getGraphLayoutCache().edit(nested);
    }

    private DefaultGraphCell _make_graph_from_graphnode(GraphNode n, TaggedDictionary<GraphNode, DefaultGraphCell> visited, GraphNode parent) {
        DefaultGraphCell current = _createNode(n.shortToString());
        _graph.getGraphLayoutCache().insert(current);

        visited.put(n, current);

        Iterator<GraphNode> it = n.getNeighbors();
        while (it.hasNext()) {
            GraphNode next = it.next();
            if (!visited.keySet().contains(next)) {
                _createEdge(current.getChildAt(0), _make_graph_from_graphnode(next, visited, n).getChildAt(0), GraphConstants.ARROW_NONE, false);
            }
            else if (!next.equals(parent)) {
                _createEdge(current.getChildAt(0), visited.get(next).getChildAt(0), GraphConstants.ARROW_NONE, false);
            }
        }

        return current;
    }

    public void readPseudoTree(PseudoTreeNode n) {
        _create_basic_graph();


        TaggedDictionary<PseudoTreeNode, DefaultGraphCell> ancestors = new TaggedDictionary<PseudoTreeNode, DefaultGraphCell>();
        _make_graph_from_pseudotreenode(n, ancestors, null);

        //layout
        JGraphFacade facade = new JGraphFacade(_graph);
        JGraphCompactTreeLayout layout = new JGraphCompactTreeLayout();
        //JGraphHierarchicalLayout layout = new JGraphHierarchicalLayout(true);

        layout.setOrientation(SwingConstants.NORTH);

        layout.setNodeDistance(50);
        layout.setLevelDistance(15);
        layout.run(facade);
        Map nested = facade.createNestedMap(true, true);
        _graph.getGraphLayoutCache().edit(nested);

        //after applying the tree layout, modify the graph to attach back edges

    }

    private DefaultGraphCell _make_graph_from_pseudotreenode(PseudoTreeNode n, TaggedDictionary<PseudoTreeNode, DefaultGraphCell> ancestors, PseudoTreeNode parent) {
        DefaultGraphCell current = _createNode(n.shortToString());
        _graph.getGraphLayoutCache().insert(current);

        TaggedDictionary<PseudoTreeNode, DefaultGraphCell> new_ancestors = new TaggedDictionary<PseudoTreeNode, DefaultGraphCell>();
        //clones all the ancestors
        Iterator<PseudoTreeNode> ita = ancestors.keySet().iterator();
        while (ita.hasNext()) {
            PseudoTreeNode a = ita.next();
            new_ancestors.put(a, ancestors.get(a));
        }
        //finally put in the new ancestors list the current node with the current edge created
        new_ancestors.put(n, current);

        Iterator<PseudoTreeNode> it = n.get_childs();
        while (it.hasNext()) {
            PseudoTreeNode next = it.next();
            if (!ancestors.keySet().contains(next)) {
                _createEdge(current.getChildAt(0), _make_graph_from_pseudotreenode(next, new_ancestors, n).getChildAt(0), GraphConstants.ARROW_CLASSIC, false);
            }
        }

        
        //creates the eventual back edges
        Iterator<PseudoTreeNode> it2 = n.get_pseudo_parents();
        while (it2.hasNext()) {
            PseudoTreeNode next = it2.next();
            _createEdge(ancestors.get(next).getChildAt(0), current.getChildAt(0), GraphConstants.ARROW_CLASSIC, true);
        }

        
        return current;
    }



    @Override
    public void setVisible(boolean v) {
        if (_graph != null) {
            this.getContentPane().removeAll();
            this.getContentPane().add(new JScrollPane(_graph));
            this.pack();
            this.setLocationRelativeTo(null);
            super.setVisible(v);
        }
    }

    private DefaultGraphCell _createNode(String name) {
        // Create vertex with the given name
        DefaultGraphCell cell = new DefaultGraphCell(name);

        GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double(0, 0, 40, 20));
        GraphConstants.setBorder(cell.getAttributes(), BorderFactory.createRaisedBevelBorder());
        GraphConstants.setGradientColor(cell.getAttributes(), Color.GREEN);
        GraphConstants.setOpaque(cell.getAttributes(), true);
        GraphConstants.setDisconnectable(cell.getAttributes(), false);
        GraphConstants.setAutoSize(cell.getAttributes(), true);

        // Add a Floating Port
        cell.addPort();

        return cell;
    }

    private void _createEdge(TreeNode source, TreeNode target, int arrow, boolean dotted) {
        DefaultEdge edge = new DefaultEdge();
        // Fetch the ports from the new vertices, and connect them with the edge
        edge.setSource(source);
        edge.setTarget(target);
        _graph.getGraphLayoutCache().insert(edge);

        if (dotted) {
            float[] v = new float[2];
            v[0] = 10;
            v[1] = 10;
            GraphConstants.setDashPattern(edge.getAttributes(), v);
        }
        GraphConstants.setLineEnd(edge.getAttributes(), arrow);
        GraphConstants.setEndFill(edge.getAttributes(), true);
    }
}
